package com.rjconsultores.ventaboletos.relatorios.impl;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;

import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.GrupoRuta;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.DataSource;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.Relatorio;
import com.rjconsultores.ventaboletos.relatorios.utilitarios.RelatorioLinhasHorarioBean;
import com.rjconsultores.ventaboletos.web.utilerias.NamedParameterStatement;

public class RelatorioLinhasHorario extends Relatorio {

	private List<RelatorioLinhasHorarioBean> lsDadosRelatorio;

	public RelatorioLinhasHorario(Map<String, Object> parametros, Connection conexao) throws Exception {
		super(parametros, conexao);
		

		this.setCustomDataSource(new DataSource(this) {
			@Override
			public void initDados() throws Exception {

				Connection conexao = this.relatorio.getConexao();

				Map<String, Object> parametros = this.relatorio.getParametros();

				@SuppressWarnings("unchecked")
				ArrayList<Ruta> lsNumLinha = (ArrayList<Ruta>) parametros.get("lsNumLinha");
				@SuppressWarnings("unchecked")
				ArrayList<Corrida> lsNumServico = (ArrayList<Corrida>) parametros.get("lsNumServico");

				String servicoFiltro = "";
				if (lsNumServico.size() > 0) {
					for (Corrida corrida : lsNumServico) {
						if (lsNumServico.indexOf(corrida) == 0) {
							servicoFiltro = "" + corrida.getId().getCorridaId();
						} else {
							servicoFiltro += ", " + corrida.getId().getCorridaId();
						}
					}
				} else {
					servicoFiltro = "TODOS";
				}
				parametros.put("SERVICO_FILTRO", servicoFiltro);

				String linhaFiltro = "";
				if (lsNumLinha.size() > 0) {
					for (Ruta ruta : lsNumLinha) {
						if (lsNumLinha.indexOf(ruta) == 0) {
							linhaFiltro = "" + ruta.getRutaId();
						} else {
							linhaFiltro += ", " + ruta.getRutaId();
						}
					}
				} else {
					linhaFiltro = "TODOS";
				}
				parametros.put("LINHA_FILTRO", linhaFiltro);

				Empresa empresa = (Empresa) parametros.get("EMPRESA");

				GrupoRuta grupoRuta = (GrupoRuta) parametros.get("GRUPORUTA");

				Integer tipoServico = (Integer) parametros.get("TIPOSERVICIO_ID");
				String sql = getSql(lsNumLinha, lsNumServico, empresa, tipoServico, grupoRuta);

				System.out.println(sql);

				NamedParameterStatement stmt = new NamedParameterStatement(conexao, sql);
				ResultSet rset = null;

				stmt.setTimestamp("DATA_INICIO", (Timestamp) parametros.get("DATA_INICIO"));
				stmt.setTimestamp("DATA_FINAL", (Timestamp) parametros.get("DATA_FINAL"));

				rset = stmt.executeQuery();

				lsDadosRelatorio = new ArrayList<RelatorioLinhasHorarioBean>();

				BigDecimal totalPassagens = BigDecimal.ZERO;
				BigDecimal totalSeguro = BigDecimal.ZERO;
				BigDecimal totalBagagens = BigDecimal.ZERO;
				BigDecimal totalSeuroOpcional = BigDecimal.ZERO;
				BigDecimal totalTotal = BigDecimal.ZERO;
				BigDecimal totalOrdinario = BigDecimal.ZERO;
				BigDecimal totalExtra = BigDecimal.ZERO;
				BigDecimal totalViagem = BigDecimal.ZERO;
				BigDecimal totalKmRodado = BigDecimal.ZERO;
				BigDecimal totalAbsoluto = BigDecimal.ZERO;
				BigDecimal totalEquivalente = BigDecimal.ZERO;
				BigDecimal mediaMPA = BigDecimal.ZERO;
				BigDecimal mediaMPE = BigDecimal.ZERO;
				BigDecimal mediaRsPorKm = BigDecimal.ZERO;
				BigDecimal totalEQ = BigDecimal.ZERO;
				BigDecimal mediaRSPorViagem = BigDecimal.ZERO;
				BigDecimal totalPaxKMOfertado = BigDecimal.ZERO;
				BigDecimal totalPaxKMTransportado = BigDecimal.ZERO;
				BigDecimal totalIAP = BigDecimal.ZERO;

				BigDecimal totalTxEmbarque = BigDecimal.ZERO;
				BigDecimal totalPedagio = BigDecimal.ZERO;

				String group = null;
				while (rset.next()) {
					RelatorioLinhasHorarioBean horarioBean = new RelatorioLinhasHorarioBean();

					group = ((String) rset.getObject("GRUPO_RUTA"));

					horarioBean.setGrupoRuta(group);

					horarioBean.setTipoLinha((String) rset.getObject("TIPO_LINHA"));

					horarioBean.setHora((String) rset.getObject("HORA"));
					horarioBean.setServico((BigDecimal) rset.getObject("SERVICO"));

					if (rset.getObject("SENTIDO") != null)
						horarioBean.convetSentido((BigDecimal) rset.getObject("SENTIDO"));
					else
						horarioBean.convetSentido(null);
					horarioBean.setLot((BigDecimal) rset.getObject("LOT"));
					horarioBean.setCla((String) rset.getObject("CLA"));
					horarioBean.setExtensao((BigDecimal) rset.getObject("EXTENSAO"));
					horarioBean.setTarifa((BigDecimal) rset.getObject("TARIFA"));
					horarioBean.setPassagens((BigDecimal) rset.getObject("PASSAGENS"));
					horarioBean.setSeguro((BigDecimal) rset.getObject("SEGURO"));
					horarioBean.setBagagens((BigDecimal) rset.getObject("BAGAGENS"));

					horarioBean.setTxEmbarque((BigDecimal) rset.getObject("TX_EMBARQUE"));
					horarioBean.setPedagio((BigDecimal) rset.getObject("PEDAGIO"));

					// Substituir a coluna Seg. Opcional por Tx. Embarque
					horarioBean.setSegOpc(horarioBean.getTxEmbarque());

					horarioBean.setOrd((BigDecimal) rset.getObject("ORD"));
					horarioBean.setExtra((BigDecimal) rset.getObject("EXTRA"));
					horarioBean.setAbsol((BigDecimal) rset.getObject("ABSOL"));

					horarioBean.setOrigem((String) rset.getObject("ORIGEM"));
					horarioBean.setDestino((String) rset.getObject("DESTINO"));

					horarioBean.setSomaExtensaoTrecho((BigDecimal) rset.getObject("EXTENSAO_TRECHO"));
					horarioBean = trecho(horarioBean);

					horarioBean = calcTotal(horarioBean);
					horarioBean = calcMediaReceitaTotal(horarioBean);

					horarioBean = calcTotalViagem(horarioBean);
					horarioBean = calcKmRodado(horarioBean);
					horarioBean = calcEquivalente(horarioBean);
					horarioBean = calcMpa(horarioBean);
					horarioBean = calcMpe(horarioBean);
					horarioBean = calcRsKm(horarioBean);
					horarioBean = calcEq(horarioBean);
					horarioBean = calcRsViagem(horarioBean);
					horarioBean = calcPaxKmOfertado(horarioBean);
					horarioBean = calcPaxKmTransportado(horarioBean);
					horarioBean = calcIap(horarioBean);

					lsDadosRelatorio.add(horarioBean);

					totalPassagens = totalPassagens.add(horarioBean.getPassagens() != null ? horarioBean.getPassagens() : BigDecimal.ZERO);
					totalSeguro = totalSeguro.add(horarioBean.getSeguro() != null ? horarioBean.getSeguro() : BigDecimal.ZERO);
					totalBagagens = totalBagagens.add(horarioBean.getBagagens() != null ? horarioBean.getBagagens() : BigDecimal.ZERO);
					totalSeuroOpcional = totalSeuroOpcional.add(horarioBean.getSegOpc() != null ? horarioBean.getSegOpc() : BigDecimal.ZERO);
					totalTotal = totalTotal.add(horarioBean.getTotal() != null ? horarioBean.getTotal() : BigDecimal.ZERO);
					totalOrdinario = totalOrdinario.add(horarioBean.getOrd() != null ? horarioBean.getOrd() : BigDecimal.ZERO);
					totalExtra = totalExtra.add(horarioBean.getExtra() != null ? horarioBean.getExtra() : BigDecimal.ZERO);
					totalViagem = totalViagem.add(horarioBean.getTotalViagem() != null ? horarioBean.getTotalViagem() : BigDecimal.ZERO);
					totalKmRodado = totalKmRodado.add(horarioBean.getKmRodado() != null ? horarioBean.getKmRodado() : BigDecimal.ZERO);
					totalAbsoluto = totalAbsoluto.add(horarioBean.getAbsol() != null ? horarioBean.getAbsol() : BigDecimal.ZERO);
					totalEquivalente = totalEquivalente.add(horarioBean.getEquivalente() != null ? horarioBean.getEquivalente() : BigDecimal.ZERO);

					totalTxEmbarque = totalTxEmbarque.add(horarioBean.getTxEmbarque() != null ? horarioBean.getTxEmbarque() : BigDecimal.ZERO);
					totalPedagio = totalPedagio.add(horarioBean.getPedagio() != null ? horarioBean.getPedagio() : BigDecimal.ZERO);

					mediaMPA = mediaMPA.add(horarioBean.getMpa() != null ? horarioBean.getMpa() : BigDecimal.ZERO);
					mediaMPE = mediaMPE.add(horarioBean.getMpe() != null ? horarioBean.getMpe() : BigDecimal.ZERO);

					mediaRsPorKm = mediaRsPorKm.add(horarioBean.getRsKm() != null ? horarioBean.getRsKm() : BigDecimal.ZERO);

					totalEQ = totalEQ.add(horarioBean.getEq() != null ? horarioBean.getEq() : BigDecimal.ZERO);

					mediaRSPorViagem = mediaRSPorViagem.add(horarioBean.getRsViagem() != null ? horarioBean.getRsViagem() : BigDecimal.ZERO);

					totalPaxKMOfertado = totalPaxKMOfertado.add(horarioBean.getPaxKmOfertado() != null ? horarioBean.getPaxKmOfertado() : BigDecimal.ZERO);
					totalPaxKMTransportado = totalPaxKMTransportado.add(horarioBean.getPaxKmTransportado() != null ? horarioBean.getPaxKmTransportado() : BigDecimal.ZERO);

					totalIAP = calcTotalIap(totalPaxKMTransportado, totalPaxKMOfertado);

				}

				BigDecimal qtdeRegistros = new BigDecimal(lsDadosRelatorio.size());

				if (lsDadosRelatorio.size() > 0) {

					setLsDadosRelatorio(lsDadosRelatorio);
					parametros.put("TOTAL_PASSAGENS", totalPassagens);
					parametros.put("TOTAL_SEGURO", totalSeguro);
					parametros.put("TOTAL_BAGAGENS", totalBagagens);
					parametros.put("TOTAL_SEURO_OPCIONAL", totalSeuroOpcional);
					parametros.put("TOTAL_TOTAL", totalTotal);
					parametros.put("TOTAL_ORDINARIO", totalOrdinario);
					parametros.put("TOTAL_EXTRA", totalExtra);
					parametros.put("TOTAL_VIAGEM", totalViagem);
					parametros.put("TOTAL_KM_RODADO", totalKmRodado);
					parametros.put("TOTAL_ABSOLUTO", totalAbsoluto);
					parametros.put("TOTAL_EQUIVALENTE", totalEquivalente);
					parametros.put("MEDIA_MPA", mediaMPA.divide(qtdeRegistros, 2, RoundingMode.HALF_EVEN));
					parametros.put("MEDIA_MPE", mediaMPE.divide(qtdeRegistros, 2, RoundingMode.HALF_EVEN));
					parametros.put("MEDIA_RS_POR_KM", mediaRsPorKm.divide(qtdeRegistros, 2, RoundingMode.HALF_EVEN));
					parametros.put("TOTAL_EQ", totalEQ);
					parametros.put("TOTAL_TX_EMBARQUE", totalTxEmbarque);
					parametros.put("TOTAL_PEDAGIO", totalPedagio);
					parametros.put("MEDIA_RS_POR_VIAGEM", mediaRSPorViagem.divide(qtdeRegistros, 2, RoundingMode.HALF_EVEN));
					parametros.put("TOTAL_PAX_KM_OFERTADO", totalPaxKMOfertado);
					parametros.put("TOTAL_PAX_KM_TRANSPORTADO", totalPaxKMTransportado);
					parametros.put("TOTAL_IAP", totalIAP);

				}
			}
		});

	}

	public List<RelatorioLinhasHorarioBean> getLsDadosRelatorio() {

		return lsDadosRelatorio;
	}

	public void setLsDadosRelatorio(List<RelatorioLinhasHorarioBean> lsDadosRelatorio) {
		this.setCollectionDataSource(new JRBeanCollectionDataSource(lsDadosRelatorio));
		this.lsDadosRelatorio = lsDadosRelatorio;
	}

	private RelatorioLinhasHorarioBean trecho(RelatorioLinhasHorarioBean horarioBean) {
		horarioBean.setTrecho(horarioBean.getOrigem() + " - " + horarioBean.getDestino());
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcTotal(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal total = horarioBean.getPassagens().add(horarioBean.getSeguro());
		total = total.add(horarioBean.getBagagens());
		horarioBean.setTotal(total);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcMediaReceitaTotal(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal mediaTotal = horarioBean.getPassagens().add(horarioBean.getSeguro());
		mediaTotal = mediaTotal.add(horarioBean.getBagagens());
		mediaTotal = mediaTotal.divide(new BigDecimal(3), 2, RoundingMode.HALF_EVEN);
		horarioBean.setMediaReceitaViagem(mediaTotal);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcTotalViagem(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal totalViagem = horarioBean.getOrd().add(horarioBean.getExtra());
		horarioBean.setTotalViagem(totalViagem);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcKmRodado(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal kmRodado = horarioBean.getTotalViagem().multiply(horarioBean.getExtensao());
		horarioBean.setKmRodado(kmRodado);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcEquivalente(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal equivalente = new BigDecimal(0);
		try {
			equivalente = horarioBean.getSomaExtensaoTrecho().divide(horarioBean.getExtensao(), 2, RoundingMode.HALF_EVEN);
		} catch (ArithmeticException e) {
			equivalente = BigDecimal.ZERO;
		} catch (NullPointerException nex) {
			equivalente = BigDecimal.ZERO;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		horarioBean.setEquivalente(equivalente);

		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcMpa(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal mpa = new BigDecimal(0);
		try {
			mpa = horarioBean.getAbsol().divide(horarioBean.getTotalViagem(), 2, RoundingMode.HALF_EVEN);
		} catch (ArithmeticException e) {
			mpa = BigDecimal.ZERO;
		} catch (NullPointerException nex) {
			mpa = BigDecimal.ZERO;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		horarioBean.setMpa(mpa);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcMpe(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal mpe = horarioBean.getEquivalente().divide(horarioBean.getTotalViagem(), 2, RoundingMode.HALF_EVEN);
		horarioBean.setMpe(mpe);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcRsKm(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal rsKm = horarioBean.getTotal().divide(horarioBean.getKmRodado(), 2, RoundingMode.HALF_EVEN);
		horarioBean.setRsKm(rsKm);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcEq(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal eq = null;
		try {
			eq = horarioBean.getMediaReceitaViagem().divide(horarioBean.getTarifa(), 2, RoundingMode.HALF_EVEN);
		} catch (ArithmeticException e) {
			eq = BigDecimal.ZERO;
		} catch (NullPointerException nex) {
			eq = BigDecimal.ZERO;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		horarioBean.setEq(eq);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcRsViagem(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal RSViagem = horarioBean.getTotal().divide(horarioBean.getTotalViagem(), 2, RoundingMode.HALF_EVEN);
		horarioBean.setRsViagem(RSViagem);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcPaxKmOfertado(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal paxKmOfertado = horarioBean.getLot().multiply(horarioBean.getTotalViagem());
		paxKmOfertado = paxKmOfertado.multiply(horarioBean.getExtensao());
		horarioBean.setPaxKmOfertado(paxKmOfertado);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcPaxKmTransportado(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal paxKmTransportado = horarioBean.getExtensao().multiply(horarioBean.getEquivalente());
		horarioBean.setPaxKmTransportado(paxKmTransportado);
		return horarioBean;
	}

	private RelatorioLinhasHorarioBean calcIap(RelatorioLinhasHorarioBean horarioBean) {
		BigDecimal iap = null;
		BigDecimal CENTO = BigDecimal.TEN.multiply(BigDecimal.TEN);
		try {
			iap = (horarioBean.getPaxKmTransportado().multiply(CENTO)).divide(horarioBean.getPaxKmOfertado(), 2, RoundingMode.HALF_EVEN);
		} catch (ArithmeticException e) {
			iap = BigDecimal.ZERO;
		} catch (NullPointerException nex) {
			iap = BigDecimal.ZERO;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		horarioBean.setIap(iap);
		return horarioBean;
	}

	private BigDecimal calcTotalIap(BigDecimal totalPaxKMTransportado, BigDecimal totalPaxKMOfertado) {
		BigDecimal iap = null;
		BigDecimal CENTO = BigDecimal.TEN.multiply(BigDecimal.TEN);
		try {
			iap = (totalPaxKMTransportado.multiply(CENTO)).divide(totalPaxKMOfertado, 2, RoundingMode.HALF_EVEN);
		} catch (ArithmeticException e) {
			iap = BigDecimal.ZERO;
		} catch (NullPointerException nex) {
			iap = BigDecimal.ZERO;
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		return iap;
	}

	@Override
	protected void processaParametros() throws Exception {
	}

	private String getSql(ArrayList<Ruta> lsNumLinha, ArrayList<Corrida> lsNumServico, Empresa empresa, Integer tipoServico, GrupoRuta grupoRuta) {
		StringBuffer sql = new StringBuffer();

		sql.append(" SELECT R.RUTA_ID, ");
		sql.append("       NVL(GR.DESCGRUPO, 'No Definido') AS GRUPO_RUTA, ");
		sql.append("       TO_CHAR(C.FECHORSALIDA, 'HH24:MI')    AS HORA, ");
		sql.append("       C.CORRIDA_ID                          AS SERVICO, ");
		sql.append("       R.INDSENTIDOIDA                       AS SENTIDO, ");
		sql.append("       DA.CANTASIENTOS                       AS LOT, ");
		sql.append("       NVL(CS.CVECLASE, '')                  AS CLA, ");
		sql.append("       NVL(TF.PRECIOORIGINAL, 0)             AS TARIFA, ");
		sql.append("       ORIGEM.CVEPARADA                      AS ORIGEM, ");
		sql.append("       DESTINO.CVEPARADA                     AS DESTINO, ");
		sql.append("       EXTENSAO, ");
		sql.append("       SUM(CJ.EQUIVALENTE * EXTENSAO) AS EXTENSAO_TRECHO, ");
		sql.append("       SUM(EE.IMPINGRESO) AS BAGAGENS, ");
		sql.append("       SUM(CJ.IMPORTESEGURO) AS SEGURO, ");
		sql.append("       SUM(CJ.IMPORTETAXAEMBARQUE) AS TX_EMBARQUE, ");
		sql.append("       SUM(CJ.IMPORTEPEDAGIO) AS PEDAGIO, ");
		sql.append("       SUM(CJ.PRECIOPAGADO) AS PASSAGENS, ");
		sql.append("       ORD, ");
		sql.append("       EXTRA, ");
		sql.append("       CASE WHEN CO.ESTADO_ID <> CD.ESTADO_ID THEN 'INTERESTADUAL' ");
		sql.append("                ELSE 'INTERMUNICIPAL' END TIPO_LINHA, ");
		sql.append("       ABSOL ");
		sql.append(" FROM ");
		sql.append("        (SELECT RS.RUTA_ID, ");
		sql.append("               SUM(NVL(T.CANTKMREAL, 0)) AS EXTENSAO ");
		sql.append("        FROM RUTA_SECUENCIA RS ");
		sql.append("               INNER JOIN TRAMO T ON ( RS.TRAMO_ID = T.TRAMO_ID ) ");
		sql.append("        WHERE  RS.ACTIVO = 1 AND T.ACTIVO = 1 ");
		sql.append("        GROUP  BY RS.RUTA_ID) TB1, ");
		sql.append("       (SELECT C.CORRIDA_ID, C.ROLOPERATIVO_ID, ");
		sql.append("               COUNT(CASE WHEN C.FECCORRIDA BETWEEN :DATA_INICIO AND :DATA_FINAL  ");
		sql.append("                     AND C.TIPOSERVICIO_ID = 1 THEN 1 ELSE NULL END) AS ORD ");
		sql.append("        FROM   CORRIDA C ");
		sql.append("        WHERE  C.ACTIVO <> 0 ");
		sql.append("        GROUP  BY C.CORRIDA_ID, C.ROLOPERATIVO_ID) TB2, ");
		sql.append("       (SELECT C.CORRIDA_ID, C.ROLOPERATIVO_ID, ");
		sql.append("               COUNT(CASE WHEN C.FECCORRIDA BETWEEN :DATA_INICIO AND :DATA_FINAL  ");
		sql.append("                     AND C.TIPOSERVICIO_ID = 2 THEN 1 ELSE NULL END) AS EXTRA ");
		sql.append("        FROM   CORRIDA C ");
		sql.append("        WHERE  C.ACTIVO <> 0 ");
		sql.append("        GROUP  BY C.CORRIDA_ID, C.ROLOPERATIVO_ID) TB3, ");
		sql.append("       (SELECT C.CORRIDA_ID, C.ROLOPERATIVO_ID, ");
		sql.append("               COUNT(CASE WHEN C.FECCORRIDA BETWEEN :DATA_INICIO AND :DATA_FINAL ");
		sql.append("                      THEN 1 ELSE NULL END) AS ABSOL ");
		sql.append("        FROM   CORRIDA C ");
		sql.append("               LEFT JOIN BOLETO B ");
		sql.append("                ON ( B.CORRIDA_ID = C.CORRIDA_ID AND B.FECCORRIDA = C.FECCORRIDA ) ");
		sql.append("        WHERE  C.ACTIVO <> 0 AND B.ACTIVO = 1 ");
		sql.append("               AND B.MOTIVOCANCELACION_ID IS NULL ");
		sql.append("        GROUP  BY C.CORRIDA_ID, C.ROLOPERATIVO_ID) TB4, ");
		sql.append("       CORRIDA C ");
		sql.append("       LEFT JOIN ");
		sql.append("          (SELECT CO.FECCORRIDA, ");
		sql.append("                  CO.CORRIDA_ID, ");
		sql.append("                  CO.ROLOPERATIVO_ID, ");
		sql.append("                  CO.RUTA_ID, ");
		sql.append("                  BO.PRECIOBASE, ");
		sql.append("                                   ROUND((BO.NUMKMVIAJE * COUNT(1) / (SELECT SUM(TR.CANTKMREAL) ");
		sql.append("                                                                      FROM   RUTA_SECUENCIA RS, TRAMO TR ");
		sql.append("                                                                      WHERE  RS.RUTA_ID = CO.RUTA_ID ");
		sql.append("                                                                      AND    RS.TRAMO_ID = TR.TRAMO_ID)), 2) EQUIVALENTE, ");
		sql.append("		                           SUM(NVL(BO.IMPORTESEGURO, 0))         AS IMPORTESEGURO, ");
		sql.append("		                           SUM(NVL(BO.IMPORTETAXAEMBARQUE, 0))   AS IMPORTETAXAEMBARQUE, ");
		sql.append("                                   SUM(NVL(BO.IMPORTEPEDAGIO, 0))        AS IMPORTEPEDAGIO, ");
		sql.append("		                           SUM(NVL(BO.PRECIOPAGADO, 0))          AS PRECIOPAGADO ");
		sql.append("                            FROM   CORRIDA CO, BOLETO BO ");
		sql.append("                            WHERE  CO.CORRIDA_ID = BO.CORRIDA_ID ");
		sql.append("                            AND    CO.FECCORRIDA = BO.FECCORRIDA ");
		sql.append("                            AND    BO.ACTIVO = 1 ");
		sql.append("                            AND    BO.INDSTATUSBOLETO != 'S' ");
		sql.append("                            AND    (BO.MOTIVOCANCELACION_ID IS NULL OR BO.MOTIVOCANCELACION_ID = 0) ");
		sql.append("                            GROUP BY CO.FECCORRIDA, ");
		sql.append("                                     CO.CORRIDA_ID, ");
		sql.append("                                     CO.ROLOPERATIVO_ID, ");
		sql.append("                                     CO.RUTA_ID, ");
		sql.append("                                     BO.PRECIOBASE, ");
		sql.append("                                     BO.NUMKMVIAJE) CJ ");
		sql.append("              ON ( CJ.CORRIDA_ID = C.CORRIDA_ID ");
		sql.append("                   AND CJ.FECCORRIDA = C.FECCORRIDA ");
		sql.append("                   AND CJ.ROLOPERATIVO_ID = C.ROLOPERATIVO_ID ) ");
		sql.append("       LEFT JOIN PARADA ORIGEM ");
		sql.append("              ON ( C.ORIGEN_ID = ORIGEM.PARADA_ID ) ");
		sql.append("       LEFT JOIN PARADA DESTINO ");
		sql.append("              ON ( C.DESTINO_ID = DESTINO.PARADA_ID ) ");
		sql.append("       LEFT OUTER JOIN CIUDAD CO ");
		sql.append("                    ON ( CO.CIUDAD_ID = ORIGEM.CIUDAD_ID ) ");
		sql.append("       LEFT OUTER JOIN CIUDAD CD ");
		sql.append("                    ON ( CO.CIUDAD_ID = DESTINO.CIUDAD_ID ) ");
		sql.append("       LEFT JOIN RUTA R ");
		sql.append("              ON ( C.RUTA_ID = R.RUTA_ID ) ");
		sql.append("       LEFT OUTER JOIN GRUPO_RUTA GR ");
		sql.append("                    ON ( R.GRUPORUTA_ID = GR.GRUPORUTA_ID ) ");
		sql.append("       LEFT JOIN ROL_OPERATIVO RO ");
		sql.append("              ON ( C.ROLOPERATIVO_ID = RO.ROLOPERATIVO_ID ) ");
		sql.append("       LEFT OUTER JOIN DIAGRAMA_AUTOBUS DA ");
		sql.append("                    ON ( DA.DIAGRAMAAUTOBUS_ID = RO.DIAGRAMAAUTOBUS_ID ) ");
		sql.append("       LEFT JOIN CLASE_SERVICIO CS ");
		sql.append("              ON ( CS.CLASESERVICIO_ID = C.CLASESERVICIO_ID ) ");
		sql.append("       LEFT JOIN EVENTO_EXTRA EE ");
		sql.append("              ON ( EE.CORRIDA_ID = C.CORRIDA_ID ");
		sql.append("                   AND EE.FECCORRIDA = C.FECCORRIDA ");
		sql.append("                   AND EE.TIPOEVENTOEXTRA_ID = 1 ) ");
		sql.append("       LEFT JOIN TARIFA TF ");
		sql.append("              ON ( TF.CLASESERVICIO_ID = C.CLASESERVICIO_ID ");
		sql.append("                   AND TF.DESTINO_ID = C.DESTINO_ID ");
		sql.append("                   AND TF.ORIGEN_ID = C.ORIGEN_ID ");
		sql.append("                   AND TF.MARCA_ID = C.MARCA_ID ");
		sql.append("                   AND TF.RUTA_ID = C.RUTA_ID ) ");
		sql.append("       LEFT OUTER JOIN VIGENCIA_TARIFA VTF ");
		sql.append("                    ON ( TF.VIGENCIATARIFA_ID = VTF.VIGENCIATARIFA_ID ");
		sql.append("                         AND C.FECCORRIDA BETWEEN VTF.FECINICIOVIGENCIA AND ");
		sql.append("                                                  VTF.FECFINVIGENCIA ) ");
		sql.append("  WHERE  CJ.FECCORRIDA BETWEEN :DATA_INICIO AND :DATA_FINAL  ");
		sql.append("       AND TB1.RUTA_ID = C.RUTA_ID ");
		sql.append("       AND TB2.CORRIDA_ID = C.CORRIDA_ID ");
		sql.append("       AND TB2.ROLOPERATIVO_ID = C.ROLOPERATIVO_ID ");
		sql.append("       AND TB3.CORRIDA_ID = C.CORRIDA_ID ");
		sql.append("       AND TB3.ROLOPERATIVO_ID = C.ROLOPERATIVO_ID ");
		sql.append("       AND TB4.CORRIDA_ID = C.CORRIDA_ID ");
		sql.append("       AND TB4.ROLOPERATIVO_ID = C.ROLOPERATIVO_ID ");

		if (empresa != null) {
			sql.append("   AND    C.EMPRESACORRIDA_ID IN (   " + empresa.getEmpresaId() + "   )     ");
		}

		if (grupoRuta != null) {
			sql.append("   AND    R.GRUPORUTA_ID IN (   " + grupoRuta.getGrupoRutaId() + "   )     ");
		}

		if (lsNumServico.size() > 0) {
			for (Corrida corrida : lsNumServico) {
				if (lsNumServico.indexOf(corrida) == 0) {
					sql.append("   AND   C.CORRIDA_ID IN     (   " + corrida.getId().getCorridaId());
				} else {
					sql.append("   ,  " + corrida.getId().getCorridaId() + "   ");
				}
			}
			sql.append("    )    ");
		}

		if (lsNumLinha.size() > 0) {
			for (Ruta ruta : lsNumLinha) {
				if (lsNumLinha.indexOf(ruta) == 0) {
					sql.append("  AND   R.RUTA_ID  IN  (   " + ruta.getRutaId());
				} else {
					sql.append("   ,  " + ruta.getRutaId() + "    ");
				}
			}
			sql.append("    )    ");
		}

		if (tipoServico > 0) {
			sql.append("  AND   C.TIPOSERVICIO_ID =  " + tipoServico + "   ");
		}

		sql.append("       AND C.ACTIVO <> 0 ");
		sql.append("       AND ORIGEM.ACTIVO = 1 ");
		sql.append("       AND DESTINO.ACTIVO = 1 ");
		sql.append("       AND R.ACTIVO = 1 ");
		sql.append("       AND RO.ACTIVO = 1 ");
		sql.append("       AND DA.ACTIVO = 1 ");
		sql.append("       AND CS.ACTIVO = 1 ");
		sql.append(" GROUP  BY R.RUTA_ID, ");
		sql.append("          NVL(GR.DESCGRUPO, 'No Definido'), ");
		sql.append("          TO_CHAR(C.FECHORSALIDA, 'HH24:MI'), ");
		sql.append("          C.CORRIDA_ID, ");
		sql.append("          R.INDSENTIDOIDA, ");
		sql.append("          TF.PRECIOORIGINAL, ");
		sql.append("          DA.CANTASIENTOS, ");
		sql.append("          CS.CVECLASE, ");
		sql.append("          EXTENSAO, ");
		sql.append("          ORD, ");
		sql.append("          EXTRA, ");
		sql.append("          ABSOL, ");
		sql.append("          CO.ESTADO_ID, ");
		sql.append("          CD.ESTADO_ID, ");
		sql.append("          ORIGEM.CVEPARADA, ");
		sql.append("          DESTINO.CVEPARADA ");
		sql.append(" ORDER  BY NVL(GR.DESCGRUPO, 'No Definido'), ");
		sql.append("          C.CORRIDA_ID ");

		return sql.toString();

	}
}
