/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EmpresaImposto;
import com.rjconsultores.ventaboletos.entidad.Estado;
import com.rjconsultores.ventaboletos.entidad.InscricaoEstadual;
import com.rjconsultores.ventaboletos.service.CiudadService;
import com.rjconsultores.ventaboletos.service.EmpresaImpostoService;
import com.rjconsultores.ventaboletos.service.EmpresaService;
import com.rjconsultores.ventaboletos.service.EstadoService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.utilerias.RegistroConDependenciaException;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.MyTextbox;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderEmpresaImposto;

/**
 * 
 * @author Rafius
 */
@Controller("editarEmpresaController")
@Scope("prototype")
public class EditarEmpresaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	private static Logger log = Logger.getLogger(EditarEmpresaController.class);
	@Autowired
	private EmpresaService empresaService;
	@Autowired
	private EmpresaImpostoService empresaImpostoService;
	@Autowired
	private EstadoService estadoService;
	@Autowired
	private CiudadService ciudadService;
	private Empresa empresa;
	private MyListbox empresaList;
	private MyTextbox txtNome;
	private MyTextbox txtCNPJ;
	private MyTextbox txtCodantt;
	private MyListbox empresaImpostoList;
	private List<EmpresaImposto> lsEmpresaImposto;
	private Button btnApagar;
	private Combobox cmbIndTipo;
	private Combobox cmbEstado;
	private Combobox cmbEstadoImposto;
	private Combobox cmbCidade;
	private Row rowEquivalencia;
	private List<Estado> lsEstados;
	private List<Ciudad> lsCidades;
	private MyTextbox numtelefono;
	
	private MyListbox inscEstadualList;
	private Combobox cmbEstadoInscEstadual;
	private MyTextbox txtInscEstadual;
	private Button btnRemoverInscEstadual;
	
	public Empresa getEmpresa() {
		return empresa;
	}

	public void setEmpresa(Empresa empresa) {
		this.empresa = empresa;
	}

	public List<Estado> getLsEstados() {
		return lsEstados;
	}

	public void setLsEstados(List<Estado> lsEstados) {
		this.lsEstados = lsEstados;
	}

	public List<Ciudad> getLsCidades() {
		return lsCidades;
	}

	public void setLsCidades(List<Ciudad> lsCidades) {
		this.lsCidades = lsCidades;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {

		empresa = (Empresa) Executions.getCurrent().getArg().get("empresa");
		empresaList = (MyListbox) Executions.getCurrent().getArg().get("empresaList");

		lsEstados = estadoService.buscarNotInEmpresaImposto(empresa);
		lsCidades = new ArrayList<Ciudad>();

		super.doAfterCompose(comp);

		empresaImpostoList.setItemRenderer(new RenderEmpresaImposto());
		empresaImpostoList.addEventListener("onDoubleClick", new EventListener() {
			@Override
			public void onEvent(Event event) throws Exception {
				EmpresaImposto empresaImposto = (EmpresaImposto) empresaImpostoList.getSelected();
				abrirEmpresaImposto(empresaImposto);
			}
		});
		
		inscEstadualList.setItemRenderer(new ListitemRenderer() {
			
			@Override
			public void render(Listitem listItem, Object item) throws Exception {
				InscricaoEstadual inscricaoEstadual = (InscricaoEstadual) item;
				
				new Listcell(inscricaoEstadual.getEstado().getNombestado()).setParent(listItem);				
				new Listcell(inscricaoEstadual.getNumInscricaoEstadual()).setParent(listItem);
				
				listItem.setAttribute("data", inscricaoEstadual);
			}
		});
		
		if (empresa.getEmpresaId() != null) {
			empresa = empresaService.obtenerID(empresa.getEmpresaId());

			lsEmpresaImposto = empresaImpostoService.buscarByEmpresa(empresa);

			empresaImpostoList.setData(lsEmpresaImposto);
			
			inscEstadualList.setData(empresa.getInscricoesEstaduaisActivas());
		}

		txtNome.focus();

		if (empresa.getEmpresaId() == null) {
			btnApagar.setVisible(Boolean.FALSE);
		} else {
			Ciudad cidade = empresa.getCidade();
			if (cidade != null) {
				cmbCidade.setText(cidade.getNombciudad());

				Estado estado = cidade.getEstado();
				if (estado != null) {
					cmbEstado.setText(estado.getNombestado());
				}
			}
		}

		if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
			rowEquivalencia.setVisible(Boolean.FALSE);
		}

	}

	public void onClick$btnSalvar(Event ev) throws InterruptedException {
		txtNome.getValue();
		cmbIndTipo.getValue();
		txtCNPJ.getValue();
		txtCodantt.getValue();
		numtelefono.getValue();

		Comboitem cbiCidade = cmbCidade.getSelectedItem();
		if (cbiCidade != null) {
			Ciudad cidade = (Ciudad) cbiCidade.getValue();

			empresa.setCidade(cidade);
		}

		try {
			if (empresa.getIndExterna() == null) {
				empresa.setIndExterna(Boolean.FALSE);
			}
			
			empresaService.suscribirActualizacion(empresa);
			empresaList.updateItem(empresa);

			Messagebox.show(Labels.getLabel("editarEmpresaController.MSG.suscribirOK"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			closeWindow();

		} catch (Exception ex) {
			log.error("editarEmpresaController: " + ex);

			Messagebox.show(Labels.getLabel(ex.getMessage()),
					Labels.getLabel("editarEmpresaController.window.title"), Messagebox.OK, Messagebox.ERROR);
		}
	}

	public String replaceTextbox(Textbox textbox) {
		String getString = textbox.getValue();
		getString = getString.replace("(", "");
		getString = getString.replaceAll("_", "");
		getString = getString.replace(")", "");
		getString = getString.replace("-", "");

		return getString;
	}

	public void onClick$btnApagar(Event ev) throws InterruptedException {
		
		int resp = Messagebox.show(
				Labels.getLabel("editarEmpresaController.MSG.borrarPergunta"),
				Labels.getLabel("editarEmpresaController.window.title"),
				Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

		if (resp == Messagebox.YES) {

			try {
				empresaService.borrar(empresa);
			} catch (RegistroConDependenciaException e) {
				Messagebox.show(
							Labels.getLabel("editarEmpresaController.MSG.noPuedeBorrar"),
							Labels.getLabel("editarEmpresaController.window.title"),
							Messagebox.OK, Messagebox.INFORMATION);
				return;
				
			}

			Messagebox.show(
					Labels.getLabel("editarEmpresaController.MSG.borrarOK"),
					Labels.getLabel("editarEmpresaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);

			empresaList.removeItem(empresa);

			closeWindow();
		}
	}

	public void onChange$cmbEstado(Event ev) {
		Comboitem cbiEstado = cmbEstado.getSelectedItem();
		if (cbiEstado != null) {
			Estado estado = (Estado) cbiEstado.getValue();

			lsCidades.addAll(ciudadService.buscarPorEstado(estado));
			BindingListModel listModelCiudad = new BindingListModelList(lsCidades, true);
			cmbCidade.setModel(listModelCiudad);
		}
	}

	public void onClick$btnAdicionarEstadoImposto(Event ev) throws InterruptedException {
		if (cmbEstadoImposto.getSelectedItem() == null) {
			Messagebox.show(
					Labels.getLabel("MSG.Error.combobox"),
					Labels.getLabel("editarPricingController.windowMarca.title"),
					Messagebox.OK, Messagebox.EXCLAMATION);
			return;
		}
		Estado estado = (Estado) cmbEstadoImposto.getSelectedItem().getValue();

		EmpresaImposto empresaImposto = new EmpresaImposto();

		empresaImposto.setEstado(estado);
		empresaImposto.setEmpresa(empresa);

		empresaImpostoService.suscribir(empresaImposto);

		lsEmpresaImposto.add(empresaImposto);

		List<EmpresaImposto> lsEmpresaImpostoAtivo = new ArrayList<EmpresaImposto>();
		for (EmpresaImposto rc : lsEmpresaImposto) {
			if (rc.getActivo()) {
				lsEmpresaImpostoAtivo.add(rc);
			}
		}
		empresaImpostoList.setData(lsEmpresaImpostoAtivo);

		cmbEstadoImposto.getSelectedItem().setVisible(false);
		cmbEstadoImposto.setSelectedIndex(-1);

		this.abrirEmpresaImposto(empresaImposto);

	}

	public void abrirEmpresaImposto(EmpresaImposto empresaImposto) {
		Map args = new HashMap();
		args.put("empresaImposto", empresaImposto);
		args.put("empresaImpostoList", empresaImpostoList);

		openWindow("/gui/catalogos/editarEmpresaImposto.zul",
				Labels.getLabel("editarEmpresaImpostoController.window.title"), args, MODAL);

	}

	public MyListbox getInscEstadualList() {
		return inscEstadualList;
	}

	public void setInscEstadualList(MyListbox inscEstadualList) {
		this.inscEstadualList = inscEstadualList;
	}
	
	public void onClick$btnAdicionarInscEstadual(Event ev) throws InterruptedException {
		Estado estado = (Estado) cmbEstadoInscEstadual.getSelectedItem().getValue();
		String inscEstadual = txtInscEstadual.getValue();
		
		InscricaoEstadual nuevaInscEstadual = new InscricaoEstadual(inscEstadual, empresa, estado, UsuarioLogado.getUsuarioLogado().getUsuarioId());		
		empresaService.actualizaInscEstadual(nuevaInscEstadual);
		empresa.getInscricoesEstaduais().add(nuevaInscEstadual);		
		
		inscEstadualList.setData(empresa.getInscricoesEstaduaisActivas());
		
		cmbEstadoInscEstadual.setSelectedItem(null);
		txtInscEstadual.setText(null);
	}
	
	public void onClick$btnRemoverInscEstadual(Event ev) throws InterruptedException {
		InscricaoEstadual inscEstadual = (InscricaoEstadual) inscEstadualList.getSelected();
		if (inscEstadual != null) {

			if (inscEstadual.getInscricaoestadualId() != null) {
				inscEstadual.setActivo(Boolean.FALSE);
				inscEstadual.setFecmodif(Calendar.getInstance().getTime());
				inscEstadual.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
				
				empresaService.actualizaInscEstadual(inscEstadual);
			}
			
			inscEstadualList.setData(empresa.getInscricoesEstaduaisActivas());
		}
	}
	
	public Combobox getCmbEstadoInscEstadual() {
		return cmbEstadoInscEstadual;
	}

	public void setCmbEstadoInscEstadual(Combobox cmbEstadoInscEstadual) {
		this.cmbEstadoInscEstadual = cmbEstadoInscEstadual;
	}

	public MyTextbox getTxtInscEstadual() {
		return txtInscEstadual;
	}

	public void setTxtInscEstadual(MyTextbox txtInscEstadual) {
		this.txtInscEstadual = txtInscEstadual;
	}

	public Button getBtnRemoverInscEstadual() {
		return btnRemoverInscEstadual;
	}

	public void setBtnRemoverInscEstadual(Button btnRemoverInscEstadual) {
		this.btnRemoverInscEstadual = btnRemoverInscEstadual;
	}
}
