/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.List;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.Executions;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Messagebox;

import com.rjconsultores.ventaboletos.entidad.PtovtaComissao;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.PtovtaComissaoService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxEstandar;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;

/**
 * 
 * @author Bruno H. G. Gouva <bruno@rjconsultores.com.br>
 * 
 */
@Controller("editarPuntoVentaComissaoController")
@Scope("prototype")
public class EditarPuntoVentaComissaoController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;

	@Autowired
	private PtovtaComissaoService ptovtaComissaoService;

	@Autowired
	private PuntoVentaService puntoVentaService;

	private MyListbox ptovtaComissaoList;
	private static Logger log = Logger.getLogger(EditarPuntoVentaComissaoController.class);

	private List<PuntoVenta> lsDestino;
	private MyComboboxEstandar cmbReceita;
	private MyComboboxEstandar cmbDestino;

	private PtovtaComissao ptovtaComissao;

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		PtovtaComissao ptovtaComissao = (PtovtaComissao) Executions.getCurrent().getArg().get("ptovtaComissao");
		this.ptovtaComissaoList = (MyListbox) Executions.getCurrent().getArg().get("ptovtaComissaoList");
		this.ptovtaComissao = ptovtaComissaoService.obtenerID(ptovtaComissao.getPtovtaComissaoId());
		this.lsDestino = puntoVentaService.obtenerTodos();
		

		super.doAfterCompose(comp);

		for (PtovtaComissao.enumReceita p : PtovtaComissao.enumReceita.values()) {
			Comboitem comboItem = new Comboitem(p.descricao());
			comboItem.setValue(p.valor());
			comboItem.setParent(cmbReceita);

		}

		if (this.ptovtaComissao.getReceita() != null)
			if (this.ptovtaComissao.getReceita().equals("RB")) {
				cmbReceita.setSelectedIndex(0);
			} else if (this.ptovtaComissao.getReceita().equals("RL")) {
				cmbReceita.setSelectedIndex(1);
			}

	}

	public void onClick$btnSalvarPtovtaComissao(Event ev) throws InterruptedException {

		if (cmbReceita.getSelectedItem() != null) {
			this.ptovtaComissao.setReceita((String) cmbReceita.getSelectedItem().getValue());
		}
		/*if (cmbDestino.getSelectedItem() != null) {
			this.ptovtaComissao.setReceita((String) cmbReceita.getSelectedItem().getValue());
		}*/
		ptovtaComissaoService.actualizacion(this.ptovtaComissao);

		Messagebox.show(
				Labels.getLabel("editarPuntoVentaComissaoController.MSG.suscribirOK"),
				Labels.getLabel("editarPuntoVentaComissaoController.window.title"),
				Messagebox.OK, Messagebox.INFORMATION);

		closeWindow();

	}

	public void onClick$btnApagarPtovtaComissao(Event ev) {
		try {
			int resp = Messagebox.show(
					Labels.getLabel("editarPuntoVentaComissaoController.MSG.borrarPergunta"),
					Labels.getLabel("editarPuntoVentaComissaoController.window.title"),
					Messagebox.YES | Messagebox.NO, Messagebox.QUESTION);

			if (resp == Messagebox.YES) {

				ptovtaComissaoService.borrar(this.ptovtaComissao);

				Messagebox.show(
						Labels.getLabel("editarPuntoVentaComissaoController.MSG.borrarOK"),
						Labels.getLabel("editarPuntoVentaComissaoController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);

				ptovtaComissaoList.removeItem(this.ptovtaComissao);

				closeWindow();
			}
		} catch (Exception ex) {
			log.error(ex);
		}
	}

	public PuntoVentaService getPuntoVentaService() {
		return puntoVentaService;
	}

	public void setPuntoVentaService(PuntoVentaService puntoVentaService) {
		this.puntoVentaService = puntoVentaService;
	}

	public List<PuntoVenta> getLsDestino() {
		return lsDestino;
	}

	public void setLsDestino(List<PuntoVenta> lsDestino) {
		this.lsDestino = lsDestino;
	}

	public PtovtaComissao getPtovtaComissao() {
		return ptovtaComissao;
	}

	public void setPtovtaComissao(PtovtaComissao ptovtaComissao) {
		this.ptovtaComissao = ptovtaComissao;
	}

	/**
	 * @return the cmbReceita
	 */
	public MyComboboxEstandar getCmbReceita() {
		return cmbReceita;
	}

	/**
	 * @param cmbReceita
	 *            the cmbReceita to set
	 */
	public void setCmbReceita(MyComboboxEstandar cmbReceita) {
		this.cmbReceita = cmbReceita;
	}


}
