package com.rjconsultores.ventaboletos.web.utilerias;

import java.math.BigDecimal;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;

import org.apache.commons.lang.StringUtils;

/**
 * 
 * @author Wilian
 *
 */
public class BigDecimalUtil {

	public static BigDecimal getStringToBigDecimal(String value, Locale locale) throws ParseException {
		if(value != null && StringUtils.isNotBlank(value)) {
			NumberFormat nf = NumberFormat.getInstance(locale);
			return new BigDecimal(nf.parse(value).toString());
		}
		
		return null;
	}
	
	public static String getBigDecimalToStringDouble2CasasDecimaisFormatado(BigDecimal value, Locale locale) {
		if(value != null) {
			NumberFormat nf = NumberFormat.getInstance(locale);
			nf.setMinimumFractionDigits(2);
			nf.setMaximumFractionDigits(2);
			return nf.format(value.doubleValue());
		}
		
		return null;
	}
	
}
