/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.utilerias.render;

import com.rjconsultores.ventaboletos.entidad.ParadaEsquema;
import com.rjconsultores.ventaboletos.utilerias.DateUtil;
import java.util.Calendar;
import java.util.Date;

import org.zkoss.zul.Listcell;
import org.zkoss.zul.Listitem;
import org.zkoss.zul.ListitemRenderer;

/**
 * 
 * @author Rafius
 */
public class RenderConfiguracionCorridaTramo implements ListitemRenderer {

	private Date dataHorInicioSistema = DateUtil.getFecInicio().getTime();

	public void render(Listitem lstm, Object o) throws Exception {
		ParadaEsquema pe = (ParadaEsquema) o;

		Listcell lc = new Listcell(pe.getNumsecuencia().toString());
		lc.setParent(lstm);

		lc = new Listcell(pe.getParada().getDescparada());
		lc.setParent(lstm);

		if (pe.getTiempoEstancia() == null) {
			lc = new Listcell("");
		} else if (DateUtil.compareDate(pe.getTiempoEstancia(), dataHorInicioSistema) == 0) {
			lc = new Listcell("");
		} else {
			Calendar c = Calendar.getInstance();
			c.setTime(pe.getTiempoEstancia());
			Long tempo = DateUtil.getElapsedMinutos(DateUtil.getFecInicio().getTime(), c.getTime());
			long minutos = (tempo % 60);
			int horas = (tempo.intValue() / 60);

			String sMinutos = String.valueOf(minutos);
			lc = new Listcell(horas + ":" + ((sMinutos.length() < 2) ? "0" + sMinutos : sMinutos));
		}
		lc.setParent(lstm);

		if (pe.getPadraoRecorrido() == null) {
			lc = new Listcell("");
		} else {
			Calendar c = Calendar.getInstance();
			c.setTime(pe.getPadraoRecorrido());
			Long tempo = DateUtil.getElapsedMinutos(DateUtil.getFecInicio().getTime(), c.getTime());
			long minutos = (tempo % 60);
			int horas = (tempo.intValue() / 60);

			String sMinutos = String.valueOf(minutos);
			lc = new Listcell(horas + ":" + ((sMinutos.length() < 2) ? "0" + sMinutos : sMinutos));
		}
		lc.setParent(lstm);

		if (pe.getExcepcionRecorrido() == null) {
			lc = new Listcell("");
		} else if (DateUtil.compareDate(pe.getExcepcionRecorrido(), dataHorInicioSistema) == 0) {
			lc = new Listcell("");
		} else {
			Calendar c = Calendar.getInstance();
			c.setTime(pe.getExcepcionRecorrido());
			Long tempo = DateUtil.getElapsedMinutos(DateUtil.getFecInicio().getTime(), c.getTime());
			long minutos = (tempo % 60);
			int horas = (tempo.intValue() / 60);

			String sMinutos = String.valueOf(minutos);
			lc = new Listcell(horas + ":" + ((sMinutos.length() < 2) ? "0" + sMinutos : sMinutos));
		}
		lc.setParent(lstm);

		lc = new Listcell(pe.getPlataforma());
		lc.setParent(lstm);

		lstm.setAttribute("data", pe);
	}
}
